"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.alert = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const react_confirm_1 = require("react-confirm");
const lodash_1 = require("lodash");
const event_listener_1 = __importDefault(require("@use-it/event-listener"));
const dialog_1 = require("./dialog");
const defaultOptions = {
    title: 'Alert',
};
function AlertDialogPresentation({ show, confirmation, proceed, options, }) {
    const { title, modalClass } = (0, lodash_1.defaults)({ ...options }, defaultOptions);
    const closeRef = (0, react_1.useRef)(() => {
        /* no-op */
    });
    (0, event_listener_1.default)('keypress', (e) => {
        if (e.key === 'Enter') {
            closeRef.current();
        }
    });
    if (!show)
        return null;
    return ((0, jsx_runtime_1.jsx)(dialog_1.Dialog, { title: title, onClose: proceed, modalFooter: (0, jsx_runtime_1.jsx)("button", { className: "btn btn-primary", onClick: () => closeRef.current(), type: "button", children: "OK" }, void 0), closeRef: closeRef, focusFirst: true, modalClass: modalClass, children: confirmation }, void 0));
}
// confirmable HOC pass props `show`, `dismiss`, `cancel` and `proceed` to your component
const ConfirmableDialog = (0, react_confirm_1.confirmable)(AlertDialogPresentation);
const _confirm = (0, react_confirm_1.createConfirmation)(ConfirmableDialog);
/**
 * Imperative-style alert function backed by `react-confirm`.
 *
 * @returns a Promise which resolves when the alert is closed.
 */
function alert(content, options) {
    return _confirm({ options, confirmation: content }).then(() => undefined); // ignore return value
}
exports.alert = alert;
