"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SubmitButton = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
/* eslint-disable react/button-has-type */
const react_1 = require("react");
const ItiReactContext_1 = require("../ItiReactContext");
const LinkButton_1 = require("./LinkButton");
/**
 * Submit button/link that displays a loading indicator and disables the onClick handler
 * when `submitting=true`.
 */
function SubmitButton({ element = 'button', submitting, children, onClick, onClickEnabled = true, enabled = true, className, type = 'submit', ...passThroughProps }) {
    const { renderLoadingIndicator } = (0, react_1.useContext)(ItiReactContext_1.ItiReactContext);
    if (submitting || !enabled) {
        onClickEnabled = false;
    }
    if (!onClickEnabled) {
        onClick = undefined;
    }
    if (typeof className === 'undefined') {
        className = '';
    }
    className += ' submit-button';
    if (element === 'button') {
        // if submitting or !onClickEnabled, set type to 'button' to prevent
        // buttons with type="submit" submitting the form
        const _type = onClickEnabled && !submitting ? type : 'button';
        return ((0, jsx_runtime_1.jsxs)("button", { ...passThroughProps, className: className, onClick: onClick, type: _type, disabled: !enabled, children: [submitting ? (0, jsx_runtime_1.jsx)("span", { className: "hidden-label", children: children }, void 0) : children, submitting && ((0, jsx_runtime_1.jsx)("div", { className: "loading-icon-container", children: renderLoadingIndicator() }, void 0))] }, void 0));
    }
    if (!enabled)
        className += ' disabled';
    return ((0, jsx_runtime_1.jsxs)(LinkButton_1.LinkButton, { ...passThroughProps, className: className, onClick: onClick, children: [children, submitting && (0, jsx_runtime_1.jsxs)("span", { children: [" ", renderLoadingIndicator()] }, void 0)] }, void 0));
}
exports.SubmitButton = SubmitButton;
