"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TabContentLoading = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const ItiReactContext_1 = require("../../ItiReactContext");
const delayMs = 200;
/**
 * The component that is displayed while a tab is loading in [[`TabManager`]].
 */
function TabContentLoading(props) {
    var _a;
    const [pastDelay, setPastDelay] = (0, react_1.useState)(false);
    (0, react_1.useEffect)(() => {
        const timer = window.setTimeout(() => {
            setPastDelay(true);
        }, delayMs);
        return () => {
            window.clearTimeout(timer);
        };
    }, []);
    const itiReactContextData = (0, react_1.useContext)(ItiReactContext_1.ItiReactContext);
    const renderLoadingIndicator = (_a = props.renderLoadingIndicator) !== null && _a !== void 0 ? _a : itiReactContextData.renderLoadingIndicator;
    // We're doing this weird thing with two LoadingIcons so that
    // - the height of the component doesn't change when pastDelay becomes true
    // - the real LoadingIcon's fadeIn animation doesn't play while it is invisible
    return ((0, jsx_runtime_1.jsxs)("div", { className: "tab-content-loading", children: [(0, jsx_runtime_1.jsx)("div", { className: pastDelay ? 'd-none' : 'invisible', children: renderLoadingIndicator() }, void 0), (0, jsx_runtime_1.jsx)("div", { className: pastDelay ? '' : 'd-none', children: renderLoadingIndicator() }, void 0)] }, void 0));
}
exports.TabContentLoading = TabContentLoading;
