"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnitInputContainer = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
/**
 * Displays an input along with a unit.
 *
 * ```
 * <UnitInputContainer unit="km">
 *     <ValidatedInput />
 * </UnitInputContainer>
 * ```
 */
function UnitInputContainer({ children, unit, className, }) {
    const classes = ['unit-input-container'];
    if (className)
        classes.push(className);
    return ((0, jsx_runtime_1.jsxs)("div", { className: classes.join(' '), children: [children, (0, jsx_runtime_1.jsx)("div", { className: "unit", children: unit }, void 0)] }, void 0));
}
exports.UnitInputContainer = UnitInputContainer;
