"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_hooks_1 = require("@testing-library/react-hooks");
const useReadiness_1 = require("./useReadiness");
it('returns an onChildReady with a stable identity', () => {
    const props = {
        defaultValue: { a: false },
        onChange: () => {
            /* no-op */
        },
    };
    const { result, rerender } = (0, react_hooks_1.renderHook)((props) => (0, useReadiness_1.useReadiness)(props.defaultValue, props.onChange), {
        initialProps: {
            ...props,
            defaultValue: { a: false },
        },
    });
    const result0 = result.current;
    rerender({ ...props, defaultValue: { a: true } });
    const result1 = result.current;
    expect(result0[0]).toBe(result1[0]);
    expect(result0[1]).toBe(result1[1]);
});
