"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const moment_timezone_1 = __importDefault(require("moment-timezone"));
const DateInputNoPicker_1 = require("./DateInputNoPicker");
describe('formatDateInputNoPickerValue', () => {
    test('UTC moment', () => {
        const m = moment_timezone_1.default.utc('2021-09-20T03:37:00.441Z');
        expect((0, DateInputNoPicker_1.formatDateInputNoPickerValue)(m, {
            includesTime: false,
        })).toBe('9/20/2021');
        expect((0, DateInputNoPicker_1.formatDateInputNoPickerValue)(m, {
            includesTime: true,
            timeZone: 'America/Chicago',
        })).toBe('9/19/2021 10:37 pm');
    });
    test('Chicago moment', () => {
        const m = moment_timezone_1.default.utc('2021-09-19T22:37:00.441-05:00');
        expect((0, DateInputNoPicker_1.formatDateInputNoPickerValue)(m, {
            includesTime: false,
        })).toBe('9/20/2021');
        expect((0, DateInputNoPicker_1.formatDateInputNoPickerValue)(m, {
            includesTime: true,
            timeZone: 'America/Chicago',
        })).toBe('9/19/2021 10:37 pm');
    });
});
test('parseDateInputNoPickerValue', () => {
    var _a, _b;
    expect((_a = (0, DateInputNoPicker_1.parseDateInputNoPickerValue)('9/20/2021', {
        includesTime: false,
    })) === null || _a === void 0 ? void 0 : _a.format()).toBe('2021-09-20T00:00:00Z');
    expect((_b = (0, DateInputNoPicker_1.parseDateInputNoPickerValue)('9/20/2021 3:37 pm', {
        includesTime: true,
        timeZone: 'America/Chicago',
    })) === null || _b === void 0 ? void 0 : _b.format()).toBe('2021-09-20T15:37:00-05:00');
});
