"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MultiSelectValidators = exports.ValidatedMultiSelect = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = __importStar(require("react"));
const react_select_1 = __importDefault(require("react-select"));
const lodash_1 = require("lodash");
const iti_react_core_1 = require("@interface-technologies/iti-react-core");
const ItiReactContext_1 = require("../../ItiReactContext");
const validation_1 = require("../../validation");
const CommonSelectProps_1 = require("./CommonSelectProps");
const SelectOption_1 = require("./SelectOption");
/**
 * A validated dropdown component based on `react-select` that allows selecting
 * multiple options.
 *
 * If any options have isFixed: true, you should sort the options so that fixed options
 * come before unfixed. Sorting the options in the component would cause poor performance
 * when there are many options and the options array is not referentially stable.
 *
 * This component is expensive to render so use `React.memo` when necessary.
 */
exports.ValidatedMultiSelect = react_1.default.memo(({ id, name, options, validators, showValidation, placeholder, className, formControlSize, width, components, isLoading, enabled = CommonSelectProps_1.defaultSelectProps.enabled, isClearable = CommonSelectProps_1.defaultSelectProps.isClearable, getStyles = CommonSelectProps_1.defaultSelectProps.getStyles, isOptionEnabled, menuIsOpen, onMenuOpen, onMenuClose, menuPlacement = CommonSelectProps_1.defaultSelectProps.menuPlacement, ...props }) => {
    const nonGroupOptions = (0, SelectOption_1.getNonGroupOptions)(options);
    const { value, onChange: _onChange } = (0, iti_react_core_1.useControlledValue)({
        value: props.value,
        onChange: props.onChange,
        defaultValue: props.defaultValue,
        fallbackValue: [],
    });
    function onChange(options0, { action, removedValue, }) {
        let options;
        switch (action) {
            case 'clear':
                options = nonGroupOptions.filter((o) => o.isFixed);
                break;
            case 'remove-value':
            case 'pop-value':
                if (removedValue && removedValue.isFixed)
                    return;
                options = options0 ? options0 : [];
                break;
            default:
                options = options0 ? options0 : [];
                break;
        }
        options = (0, lodash_1.sortBy)(options, (o) => !o.isFixed);
        const newValue = options.map((o) => o.value);
        _onChange(newValue);
    }
    const validatorOutput = (0, iti_react_core_1.useValidation)({
        value,
        name,
        onValidChange: props.onValidChange,
        validators,
        validationKey: props.validationKey,
        asyncValidator: props.asyncValidator,
        onAsyncError: props.onAsyncError,
        formLevelValidatorOutput: props.formLevelValidatorOutput,
    });
    const { themeColors } = (0, react_1.useContext)(ItiReactContext_1.ItiReactContext);
    const optionMap = new Map(nonGroupOptions.map((o) => [o.value, o]));
    // Order of the `value` array determines the order the selected options are displayed in.
    // This way, when a new option is added, it is appended to the selected options instead of
    // potentaily being inserted in the middle
    const selectedOptions = value
        .map((v) => optionMap.get(v))
        .filter((o) => !!o);
    let isOptionDisabled;
    if (isOptionEnabled)
        isOptionDisabled = (o) => !isOptionEnabled(o);
    return ((0, jsx_runtime_1.jsx)(validation_1.ValidationFeedback, { validatorOutput: validatorOutput, showValidation: showValidation, children: (0, jsx_runtime_1.jsx)(react_select_1.default, { inputId: id, name: name, className: className, options: options, placeholder: placeholder, value: selectedOptions, onChange: onChange, isClearable: isClearable, isDisabled: !enabled, isLoading: isLoading, isOptionDisabled: isOptionDisabled, styles: getStyles({
                valid: !validatorOutput,
                showValidation,
                themeColors,
                width,
                formControlSize,
                isMulti: true,
            }), "aria-label": props['aria-label'], "aria-labelledby": props['aria-labelledby'], 
            // eslint-disable-next-line -- TODO:SAM
            components: components, isMulti: true, menuIsOpen: menuIsOpen, onMenuOpen: onMenuOpen, onMenuClose: onMenuClose, menuPlacement: menuPlacement, filterOption: SelectOption_1.filterOption }, void 0) }, void 0));
});
function required() {
    return (value) => {
        if (value.length === 0)
            return iti_react_core_1.Validators.required()('');
        return undefined;
    };
}
exports.MultiSelectValidators = {
    required,
};
