"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const TimeZoneInput_1 = require("./TimeZoneInput");
describe('resolve value', () => {
    it('does not change value if there is a matching option', () => {
        const onChange = jest.fn();
        (0, TimeZoneInput_1.resolveValue)('America/Denver', onChange);
        expect(onChange).not.toHaveBeenCalled();
    });
    it('does not change value if there is no matching option or time zone', () => {
        const onChange = jest.fn();
        (0, TimeZoneInput_1.resolveValue)('America/Foobar', onChange);
        expect(onChange).not.toHaveBeenCalled();
    });
    it('changes value if there is not a matching option', () => {
        const onChange = jest.fn();
        (0, TimeZoneInput_1.resolveValue)('America/Creston', onChange);
        expect(onChange).toHaveBeenCalledWith('America/Whitehorse');
    });
});
