"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("@testing-library/react");
const real_cancellable_promise_1 = require("real-cancellable-promise");
const ValidatedInput_1 = require("./ValidatedInput");
it('does not update the component asynchoronously when there is no asyncValidator', async () => {
    const consoleErrorMock = jest.fn();
    console.error = consoleErrorMock;
    (0, react_1.render)((0, jsx_runtime_1.jsx)(ValidatedInput_1.ValidatedInput, { name: "test", value: "", onChange: jest.fn(), validators: [], showValidation: false }, void 0));
    // purposefully not using waitForReactUpdates which uses `act`
    const delay = real_cancellable_promise_1.CancellablePromise.delay(2000);
    jest.runAllTimers();
    await delay;
    // ensure no "component updated outside of an act() call" error
    expect(consoleErrorMock).not.toHaveBeenCalled();
});
